Number.prototype.formatMoney = function(c, d, t){
var n = this, c = isNaN(c = Math.abs(c)) ? 2 : c, d = d == undefined ? "," : d, t = t == undefined ? "." : t, s = n < 0 ? "-" : "", i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "", j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
};

function s4() {
  return Math.floor((1 + Math.random()) * 0x10000)
             .toString(16)
             .substring(1);
};

function guid() {
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
         s4() + '-' + s4() + s4() + s4();
}

function configDatePicker()
{
    $.datepicker.regional['pt-BR'] = {
    closeText: 'Fechar',
    prevText: '&#x3c;Anterior',
    nextText: 'Pr&oacute;ximo&#x3e;',
    currentText: 'Hoje',
    monthNames: ['Janeiro','Fevereiro','Mar&ccedil;o','Abril','Maio','Junho',
    'Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'],
    monthNamesShort: ['Jan','Fev','Mar','Abr','Mai','Jun',
    'Jul','Ago','Set','Out','Nov','Dez'],
    dayNames: ['Domingo','Segunda-feira','Ter&ccedil;a-feira','Quarta-feira','Quinta-feira','Sexta-feira','Sabado'],
    dayNamesShort: ['Dom','Seg','Ter','Qua','Qui','Sex','Sab '],
    dayNamesMin: ['Dom','Seg','Ter','Qua','Qui','Sex','Sab '],
    weekHeader: 'Sm',
    dateFormat: 'dd/mm/yy',
    firstDay: 0,
    isRTL: false,
    showMonthAfterYear: false,
    yearSuffix: ''};

    $.datepicker.setDefaults($.datepicker.regional['pt-BR']);
}

function applyFormats()
{
    // Remove as mascaras para nao duplicar!!
    $(".format-cep").unmask();
    $(".format-cpf").unmask();
    $(".format-cnpj").unmask();
    $(".format-phone").unmask();
    $(".format-money").unmaskMoney();
    $(".format-decimal").unmaskMoney();
    $(".format-decimal-4").unmaskMoney();
    $(".format-decimal-3").unmaskMoney();
    $(".format-hhmm").unmask();
    
    // WorkAround Celular são paulo
    $.mask.definitions['F']='[9 ]';

    // Aplica mascara aos campos
    $(".format-cep").mask("99999-999",{placeholder:"_"});
    $(".format-cpf").mask("999.999.999-99",{placeholder:"_"});
    $(".format-cnpj").mask("99.999.999/9999-99",{placeholder:"_"});
   
    if($(".format-phone").length > 0 )
    {
	var phone_val = $(".format-phone").val().replace(/\D/g, '');
	if( phone_val.length > 10 )
	    $(".format-phone").mask("(99) 99999-999?9",{placeholder:"_"});
	else
	    $(".format-phone").mask("(99) 9999-9999?9",{placeholder:"_"});
    }	
    
    $(".format-phone").live('focusout', function (event) {  
            var target, phone, element;  
            target = (event.currentTarget) ? event.currentTarget : event.srcElement;  
            phone = target.value.replace(/\D/g, '');
            element = $(target);  
            element.unmask();  
            if(phone.length > 10) {  
                element.mask("(99) 99999-999?9");  
            } else {  
                element.mask("(99) 9999-9999?9");  
            }  
        });
    
    $(".format-money").maskMoney({symbol:"",decimal:",",thousands:".",precision:2});
    $(".format-decimal").maskMoney({symbol:"",decimal:",",thousands:".",precision:2});
    $(".format-decimal-4").maskMoney({symbol:"",decimal:",",thousands:".",precision:4});
    $(".format-decimal-3").maskMoney({symbol:"",decimal:",",thousands:".",precision:3});
    $(".format-hhmm").mask("99:99",{placeholder:"_"});
    var d = new Date();
    $(".format-date").datepicker({changeYear: true, yearRange: "1900:" + d.getFullYear()});
}

$(document).ready(function()
{
   configDatePicker();
   applyFormats();
});


