<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Admin
 *
 * @author mandre
 */
class App_Access_Frontend_Auth implements Zend_Auth_Adapter_Interface {
//put your code here

    private $identity;
    private $password;

    public $em;
    /**
    * Sets username and password for authentication
    *
    * @return void
    */
    public  function __construct()
    {

    }

    /**
    * Performs an authentication attempt
    *
    * @throws Zend_Auth_Adapter_Exception If authentication cannot
    * be performed
    * @return Zend_Auth_Result
    */
    public function authenticate()
    {
        $resultAuth = array (
            'code'      => Zend_Auth_Result::FAILURE,
            'identity'  => $this->identity,
            'messages'  => array()
        );

        $qb = $this->em->createQueryBuilder();
        $qb->select("u")
           ->from("Entity\User","u")
           ->where("u.email=:email")
           ->andWhere("u.password=:password")
           ->setParameter("email",$this->identity)
           ->setParameter("password",$this->password);

        $query = $qb->getQuery();

        $result = $query->getResult();

        $admin = $result[0];

        if(!is_null($admin))
        {
            $resultAuth['code'] = Zend_Auth_Result::SUCCESS;
            $resultAuth['messages'][] = 'Autenticação aprovada';
            $authNamespace = new Zend_Session_Namespace('Zend_Auth');
            $authNamespace->module = "admin";
        }
        else
        {
            $resultAuth['messages'][] = 'Falha na autenticação';
        }

        $result = new Zend_Auth_Result($resultAuth['code'], $resultAuth['identity'] , $resultAuth['messages']);

        return $result;
    }

    public function setIdentity($identity)
    {
      $this->identity = $identity;
      return $this;
    }

    public function setCredential($password)
    {
      $this->password = $password;
      return $this;
    }
    
}