<?php

class Frontend_LoginController extends Zend_Controller_Action
{
    public function  preDispatch()
    {
        $this->em = $this->getInvokeArg('bootstrap')->em;
    }

    public function indexAction()
    {
        $this->_helper->layout->disableLayout();
        
        if($this->_request->isPost())
        {
            $email = $this->getRequest()->getParam("email");
            $password = $this->getRequest()->getParam("password");

            $this->view->email = $email;
                    
            $auth = Zend_Auth::getInstance();

            $authAdapter = new App_Access_Frontend_Auth();

            $authAdapter->em = $this->em;

            $authAdapter->setIdentity($email)
                        ->setCredential(md5($password));

            $result = $auth->authenticate($authAdapter);

            if (!$result->isValid())
            {
                
                $this->view->failure = true;
            }
            else
            {
                $this->_redirect("/");
            }

        }


    }

    public function logoutAction() {

        $auth = Zend_Auth::getInstance();
        $auth->clearIdentity();

        $this->_redirect("/");

    }

}
