<?php
class Permission
{
    
    const VIEW_USER = "A01";
    const ADD_EDIT_USER = "A02";
    const DELETE_USER = "A03";

    const VIEW_CUSTOMER = "B01";
    const ADD_EDIT_CUSTOMER = "B02";
    const DELETE_CUSTOMER = "B03";
    
    const VIEW_PRODUCT = "C01";
    const ADD_EDIT_PRODUCT = "C02";
    const DELETE_PRODUCT = "C03";

    const DO_SALE = "D01";
    const VIEW_SALE_HISTORY = "D02";

    const CONTROL_STOCK = "E01";
    const VIEW_STOCK_HISTORY = "E02";
    
    private static $permissions = array(
      "A01"=>"Visualizar",  
      "A02"=>"Adicionar / Editar",       
      "A03"=>"Excluir",       
      "B01"=>"Visualizar",  
      "B02"=>"Adicionar / Editar",       
      "B03"=>"Excluir",       
      "C01"=>"Visualizar",  
      "C02"=>"Adicionar / Editar",       
      "C03"=>"Excluir",        
      "D01"=>"Efetuar",       
      "D02"=>"Ver histórico",        
      "E01"=>"Controlar",       
      "E02"=>"Ver histórico",        
    );
    
    private static $group = array(
        "A"=>"Usuários",
        "B"=>"Clientes",
        "C"=>"Produtos",
        "D"=>"Vendas",
        "E"=>"Estoque",
    );
    
    public static function getList()
    {
        return self::$permissions;
    }

    public static function getGroupedList()
    {
        $temp = array();
        foreach(self::$group as $gk => $gv)
        {
            foreach(self::$permissions as $pk => $pv)
            {
                if($gk == substr($pk,0,1))
                {
                    $temp[$gv][$pk]=$pv;
                }
            }
        }   
        return $temp;
    }        

    public static function isChecked($key,$data,$as = true)
    {
        if(strpos($data,"[$key]")!==false)
        {
            return $as;
        }
    }
}
?>
