<?php

class App_Layout_Manager extends Zend_Controller_Plugin_Abstract {

    public function preDispatch(Zend_Controller_Request_Abstract $request) {

        // pega o modulo atual
        $modulo = $request->getModuleName();

        // pega o view para setar o nome do modulo no template
        $layout = Zend_Layout::startMvc(array(
            'layoutPath' => APPLICATION_PATH .  '/modules/' . $modulo . '/layouts/scripts',
            'layout' => 'layout'
        ));
        $view = $layout->getView();
        $view->modulo_atual = $modulo;
        $view->baseurl = Zend_Controller_Front::getInstance()->getBaseUrl() . '/';
    }


}
