<?php
class BreadCrumb
{
    public static $data = array();
    
    public static function clear()
    {
        self::$data = array();
    }
    
    public static function append($text,$link)
    {
        self::$data[] = array("text"=>$text,"link"=>$link);
    }
    
    public static function render()
    {
        $count = 1;
        foreach(self::$data as $item)
        {
            $text = $item["text"];
            $link = $item["link"];
            
            if($count >= count(self::$data))
                $active = "active";
            else
                $active = "";
            
            if(empty($active))
            {
                echo "<li class='{$active}'><a href='{$link}'>{$text}</a></li>";
                echo "<span class='divider'>/</span>";
                echo "</li>";
            }
            else
            {
                echo "<li class='{$active}'>{$text}</li>";
            }    
            
            $count++;
        }
    }

}
?>
